// Copyright 2004-2008, wxRuby development team
// released under the MIT-like wxRuby2 license

#if !defined(_wxRichTextHTMLHandler_h_)
#define _wxRichTextHTMLHandler_h_

class wxRichTextHTMLHandler : public wxRichTextFileHandler
{
public:
  wxRichTextHTMLHandler(const wxString& name = wxT("HTML"), 
                        const wxString& ext = wxT("html"), 
                        int type = wxRICHTEXT_TYPE_HTML);

  bool CanSave();
  bool CanLoad();
  bool CanHandle(const wxString& filename) const;

  void SetTemporaryImageLocations(const wxArrayString& locations);
  const wxArrayString& GetTemporaryImageLocations() const;
  void ClearTemporaryImageLocations();

  /// Delete the in-memory or temporary files generated by the last operation
  bool DeleteTemporaryImages();
  static bool DeleteTemporaryImages(int flags, 
                                    const wxArrayString& imageLocations);
  static void SetFileCounter(int counter);

  void SetTempDir(const wxString& tempDir);
  const wxString& GetTempDir() const;

  void SetFontSizeMapping(const wxArrayInt& fontSizeMapping);
  wxArrayInt GetFontSizeMapping() const;
};

#endif
